import bundle from '@nurdiansyah/rollup/configs/module.config'
import path from 'path'
import fs from 'fs-extra'
import alias from '@rollup/plugin-alias'

const config = bundle(
  {
    input: 'src/index.ts',
    output: '',
    isPublish: true,
  },
  {
    nodeResolveOptions: {
      preferBuiltins: true,
    },
  }
)

config.output = {
  dir: 'dist',
  format: 'esm',
}

config.plugins = [
  alias({
    entries: [
      {
        find: 'bytemd',
        replacement: '@deboxsoft/bytemd',
      },
      {
        find: /@bytemd\/plugin-(.*)/,
        replacement: '@deboxsoft/bytemd-plugin-$1',
      },
    ],
  }),
  ...config.plugins,
]

const pkg = fs.readJsonSync(path.resolve('package.json'))
const externalDependencies = {
  ...(pkg.peerDependencies || {}),
  ...(pkg.optionalDependencies || {}),
}
config.external = Object.keys(externalDependencies)
export default config
